/* handle.c generated by valac 0.24.0, the Vala compiler
 * generated from handle.vala, do not modify */

/* vim:set et sts=4 sw=4:
 *
 * ibus - The Input Bus
 *
 * Copyright(c) 2011 Peng Huang <shawn.p.huang@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301
 * USA
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <string.h>
#include <cairo.h>
#include <float.h>
#include <math.h>


#define TYPE_HANDLE (handle_get_type ())
#define HANDLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HANDLE, Handle))
#define HANDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HANDLE, HandleClass))
#define IS_HANDLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HANDLE))
#define IS_HANDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HANDLE))
#define HANDLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HANDLE, HandleClass))

typedef struct _Handle Handle;
typedef struct _HandleClass HandleClass;
typedef struct _HandlePrivate HandlePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _Handle {
	GtkEventBox parent_instance;
	HandlePrivate * priv;
};

struct _HandleClass {
	GtkEventBoxClass parent_class;
};

struct _HandlePrivate {
	gboolean m_move_begined;
	GdkRectangle m_workarea;
	GdkPoint m_press_pos;
};


static gpointer handle_parent_class = NULL;

GType handle_get_type (void) G_GNUC_CONST;
#define HANDLE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_HANDLE, HandlePrivate))
enum  {
	HANDLE_DUMMY_PROPERTY
};
Handle* handle_new (void);
Handle* handle_construct (GType object_type);
static void handle_real_realize (GtkWidget* base);
static gboolean handle_real_button_press_event (GtkWidget* base, GdkEventButton* event);
static gboolean handle_real_button_release_event (GtkWidget* base, GdkEventButton* event);
static gboolean handle_real_motion_notify_event (GtkWidget* base, GdkEventMotion* event);
static gboolean handle_real_draw (GtkWidget* base, cairo_t* cr);
static void handle_finalize (GObject* obj);


Handle* handle_construct (GType object_type) {
	Handle * self = NULL;
	GdkEventMask mask = 0;
	self = (Handle*) g_object_new (object_type, NULL);
	gtk_widget_set_size_request ((GtkWidget*) self, 6, -1);
	mask = ((GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK) | GDK_BUTTON1_MOTION_MASK;
	gtk_widget_set_events ((GtkWidget*) self, (gint) mask);
	self->priv->m_move_begined = FALSE;
	return self;
}


Handle* handle_new (void) {
	return handle_construct (TYPE_HANDLE);
}


static void handle_real_realize (GtkWidget* base) {
	Handle * self;
	self = (Handle*) base;
	GTK_WIDGET_CLASS (handle_parent_class)->realize ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_EVENT_BOX, GtkEventBox));
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gboolean handle_real_button_press_event (GtkWidget* base, GdkEventButton* event) {
	Handle * self;
	gboolean result = FALSE;
	GdkEventButton* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	GdkRectangle _tmp4_ = {0};
	GdkRectangle _tmp5_ = {0};
	gint x = 0;
	gint y = 0;
	GtkWindow* toplevel = NULL;
	GtkWidget* _tmp108_ = NULL;
	GtkWindow* _tmp109_ = NULL;
	GtkWindow* _tmp110_ = NULL;
	gint _tmp111_ = 0;
	gint _tmp112_ = 0;
	GdkEventButton* _tmp113_ = NULL;
	gdouble _tmp114_ = 0.0;
	gint _tmp115_ = 0;
	GdkEventButton* _tmp116_ = NULL;
	gdouble _tmp117_ = 0.0;
	gint _tmp118_ = 0;
	self = (Handle*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event;
	_tmp1_ = _tmp0_->button;
	if (_tmp1_ != ((guint) 1)) {
		result = FALSE;
		return result;
	}
	_tmp2_ = G_MAXINT;
	_tmp3_ = G_MAXINT;
	memset (&_tmp4_, 0, sizeof (GdkRectangle));
	_tmp4_.x = 0;
	_tmp4_.y = 0;
	_tmp4_.width = _tmp2_;
	_tmp4_.height = _tmp3_;
	self->priv->m_workarea = _tmp4_;
	_tmp5_ = self->priv->m_workarea;
	{
		gboolean _tmp6_ = FALSE;
		_tmp6_ = TRUE;
		while (TRUE) {
			GdkWindow* root = NULL;
			GdkWindow* _tmp7_ = NULL;
			GdkWindow* _tmp8_ = NULL;
			GdkAtom property = 0U;
			GdkAtom _tmp9_ = 0U;
			GdkAtom type = 0U;
			GdkAtom _tmp10_ = 0U;
			GdkAtom actual_type = 0U;
			gint format = 0;
			guchar* data = NULL;
			gint data_length1 = 0;
			gint _data_size_ = 0;
			gboolean _result_ = FALSE;
			GdkWindow* _tmp11_ = NULL;
			GdkAtom _tmp12_ = 0U;
			GdkAtom _tmp13_ = 0U;
			glong _tmp14_ = 0L;
			GdkAtom _tmp15_ = 0U;
			gint _tmp16_ = 0;
			guint8* _tmp17_ = NULL;
			gint _tmp18_ = 0;
			gboolean _tmp19_ = FALSE;
			gboolean _tmp20_ = FALSE;
			gboolean _tmp21_ = FALSE;
			gboolean _tmp22_ = FALSE;
			gboolean _tmp23_ = FALSE;
			gint index = 0;
			guchar* _tmp28_ = NULL;
			gint _tmp28__length1 = 0;
			guchar _tmp29_ = '\0';
			guchar* _tmp30_ = NULL;
			gint _tmp30__length1 = 0;
			guchar _tmp31_ = '\0';
			guchar* _tmp32_ = NULL;
			gint _tmp32__length1 = 0;
			guchar _tmp33_ = '\0';
			guchar* _tmp34_ = NULL;
			gint _tmp34__length1 = 0;
			guchar _tmp35_ = '\0';
			GdkAtom _tmp36_ = 0U;
			GdkAtom _tmp37_ = 0U;
			GdkWindow* _tmp38_ = NULL;
			GdkAtom _tmp39_ = 0U;
			GdkAtom _tmp40_ = 0U;
			glong _tmp41_ = 0L;
			GdkAtom _tmp42_ = 0U;
			gint _tmp43_ = 0;
			guint8* _tmp44_ = NULL;
			gint _tmp45_ = 0;
			gboolean _tmp46_ = FALSE;
			gboolean _tmp47_ = FALSE;
			gboolean _tmp48_ = FALSE;
			gboolean _tmp49_ = FALSE;
			gboolean _tmp50_ = FALSE;
			gint i = 0;
			gint _tmp56_ = 0;
			guchar* _tmp57_ = NULL;
			gint _tmp57__length1 = 0;
			gint _tmp58_ = 0;
			guchar _tmp59_ = '\0';
			guchar* _tmp60_ = NULL;
			gint _tmp60__length1 = 0;
			gint _tmp61_ = 0;
			guchar _tmp62_ = '\0';
			guchar* _tmp63_ = NULL;
			gint _tmp63__length1 = 0;
			gint _tmp64_ = 0;
			guchar _tmp65_ = '\0';
			guchar* _tmp66_ = NULL;
			gint _tmp66__length1 = 0;
			gint _tmp67_ = 0;
			guchar _tmp68_ = '\0';
			gint _tmp69_ = 0;
			guchar* _tmp70_ = NULL;
			gint _tmp70__length1 = 0;
			gint _tmp71_ = 0;
			guchar _tmp72_ = '\0';
			guchar* _tmp73_ = NULL;
			gint _tmp73__length1 = 0;
			gint _tmp74_ = 0;
			guchar _tmp75_ = '\0';
			guchar* _tmp76_ = NULL;
			gint _tmp76__length1 = 0;
			gint _tmp77_ = 0;
			guchar _tmp78_ = '\0';
			guchar* _tmp79_ = NULL;
			gint _tmp79__length1 = 0;
			gint _tmp80_ = 0;
			guchar _tmp81_ = '\0';
			gint _tmp82_ = 0;
			guchar* _tmp83_ = NULL;
			gint _tmp83__length1 = 0;
			gint _tmp84_ = 0;
			guchar _tmp85_ = '\0';
			guchar* _tmp86_ = NULL;
			gint _tmp86__length1 = 0;
			gint _tmp87_ = 0;
			guchar _tmp88_ = '\0';
			guchar* _tmp89_ = NULL;
			gint _tmp89__length1 = 0;
			gint _tmp90_ = 0;
			guchar _tmp91_ = '\0';
			guchar* _tmp92_ = NULL;
			gint _tmp92__length1 = 0;
			gint _tmp93_ = 0;
			guchar _tmp94_ = '\0';
			gint _tmp95_ = 0;
			guchar* _tmp96_ = NULL;
			gint _tmp96__length1 = 0;
			gint _tmp97_ = 0;
			guchar _tmp98_ = '\0';
			guchar* _tmp99_ = NULL;
			gint _tmp99__length1 = 0;
			gint _tmp100_ = 0;
			guchar _tmp101_ = '\0';
			guchar* _tmp102_ = NULL;
			gint _tmp102__length1 = 0;
			gint _tmp103_ = 0;
			guchar _tmp104_ = '\0';
			guchar* _tmp105_ = NULL;
			gint _tmp105__length1 = 0;
			gint _tmp106_ = 0;
			guchar _tmp107_ = '\0';
			if (!_tmp6_) {
				if (!FALSE) {
					break;
				}
			}
			_tmp6_ = FALSE;
			_tmp7_ = gdk_get_default_root_window ();
			_tmp8_ = _g_object_ref0 (_tmp7_);
			root = _tmp8_;
			_tmp9_ = gdk_atom_intern ("_NET_CURRENT_DESKTOP", FALSE);
			property = _tmp9_;
			_tmp10_ = gdk_atom_intern ("CARDINAL", FALSE);
			type = _tmp10_;
			_tmp11_ = root;
			_tmp12_ = property;
			_tmp13_ = type;
			_tmp14_ = G_MAXLONG;
			_tmp19_ = gdk_property_get (_tmp11_, _tmp12_, _tmp13_, (gulong) 0, (gulong) _tmp14_, 0, &_tmp15_, &_tmp16_, &_tmp18_, &_tmp17_);
			actual_type = _tmp15_;
			format = _tmp16_;
			data = (g_free (data), NULL);
			data = _tmp17_;
			data_length1 = _tmp18_;
			_data_size_ = data_length1;
			_result_ = _tmp19_;
			_tmp23_ = _result_;
			if (!_tmp23_) {
				_tmp22_ = TRUE;
			} else {
				GdkAtom _tmp24_ = 0U;
				GdkAtom _tmp25_ = 0U;
				_tmp24_ = actual_type;
				_tmp25_ = type;
				_tmp22_ = _tmp24_ != _tmp25_;
			}
			if (_tmp22_) {
				_tmp21_ = TRUE;
			} else {
				gint _tmp26_ = 0;
				_tmp26_ = format;
				_tmp21_ = _tmp26_ != 32;
			}
			if (_tmp21_) {
				_tmp20_ = TRUE;
			} else {
				guchar* _tmp27_ = NULL;
				gint _tmp27__length1 = 0;
				_tmp27_ = data;
				_tmp27__length1 = data_length1;
				_tmp20_ = _tmp27__length1 != 4;
			}
			if (_tmp20_) {
				data = (g_free (data), NULL);
				_g_object_unref0 (root);
				break;
			}
			_tmp28_ = data;
			_tmp28__length1 = data_length1;
			_tmp29_ = _tmp28_[0];
			_tmp30_ = data;
			_tmp30__length1 = data_length1;
			_tmp31_ = _tmp30_[1];
			_tmp32_ = data;
			_tmp32__length1 = data_length1;
			_tmp33_ = _tmp32_[2];
			_tmp34_ = data;
			_tmp34__length1 = data_length1;
			_tmp35_ = _tmp34_[3];
			index = (gint) (((_tmp29_ | (_tmp31_ << 8)) | (_tmp33_ << 16)) | (_tmp35_ << 24));
			_tmp36_ = gdk_atom_intern ("_NET_WORKAREA", FALSE);
			property = _tmp36_;
			_tmp37_ = gdk_atom_intern ("CARDINAL", FALSE);
			type = _tmp37_;
			_tmp38_ = root;
			_tmp39_ = property;
			_tmp40_ = type;
			_tmp41_ = G_MAXLONG;
			_tmp46_ = gdk_property_get (_tmp38_, _tmp39_, _tmp40_, (gulong) 0, (gulong) _tmp41_, 0, &_tmp42_, &_tmp43_, &_tmp45_, &_tmp44_);
			actual_type = _tmp42_;
			format = _tmp43_;
			data = (g_free (data), NULL);
			data = _tmp44_;
			data_length1 = _tmp45_;
			_data_size_ = data_length1;
			_result_ = _tmp46_;
			_tmp50_ = _result_;
			if (!_tmp50_) {
				_tmp49_ = TRUE;
			} else {
				GdkAtom _tmp51_ = 0U;
				GdkAtom _tmp52_ = 0U;
				_tmp51_ = actual_type;
				_tmp52_ = type;
				_tmp49_ = _tmp51_ != _tmp52_;
			}
			if (_tmp49_) {
				_tmp48_ = TRUE;
			} else {
				gint _tmp53_ = 0;
				_tmp53_ = format;
				_tmp48_ = _tmp53_ != 32;
			}
			if (_tmp48_) {
				_tmp47_ = TRUE;
			} else {
				guchar* _tmp54_ = NULL;
				gint _tmp54__length1 = 0;
				gint _tmp55_ = 0;
				_tmp54_ = data;
				_tmp54__length1 = data_length1;
				_tmp55_ = index;
				_tmp47_ = _tmp54__length1 < ((_tmp55_ + 1) * 16);
			}
			if (_tmp47_) {
				data = (g_free (data), NULL);
				_g_object_unref0 (root);
				break;
			}
			_tmp56_ = index;
			i = (_tmp56_ * 4) * 4;
			_tmp57_ = data;
			_tmp57__length1 = data_length1;
			_tmp58_ = i;
			_tmp59_ = _tmp57_[_tmp58_];
			_tmp60_ = data;
			_tmp60__length1 = data_length1;
			_tmp61_ = i;
			_tmp62_ = _tmp60_[_tmp61_ + 1];
			_tmp63_ = data;
			_tmp63__length1 = data_length1;
			_tmp64_ = i;
			_tmp65_ = _tmp63_[_tmp64_ + 2];
			_tmp66_ = data;
			_tmp66__length1 = data_length1;
			_tmp67_ = i;
			_tmp68_ = _tmp66_[_tmp67_ + 3];
			self->priv->m_workarea.x = (gint) (((_tmp59_ | (_tmp62_ << 8)) | (_tmp65_ << 16)) | (_tmp68_ << 24));
			_tmp69_ = i;
			i = _tmp69_ + 4;
			_tmp70_ = data;
			_tmp70__length1 = data_length1;
			_tmp71_ = i;
			_tmp72_ = _tmp70_[_tmp71_];
			_tmp73_ = data;
			_tmp73__length1 = data_length1;
			_tmp74_ = i;
			_tmp75_ = _tmp73_[_tmp74_ + 1];
			_tmp76_ = data;
			_tmp76__length1 = data_length1;
			_tmp77_ = i;
			_tmp78_ = _tmp76_[_tmp77_ + 2];
			_tmp79_ = data;
			_tmp79__length1 = data_length1;
			_tmp80_ = i;
			_tmp81_ = _tmp79_[_tmp80_ + 3];
			self->priv->m_workarea.y = (gint) (((_tmp72_ | (_tmp75_ << 8)) | (_tmp78_ << 16)) | (_tmp81_ << 24));
			_tmp82_ = i;
			i = _tmp82_ + 4;
			_tmp83_ = data;
			_tmp83__length1 = data_length1;
			_tmp84_ = i;
			_tmp85_ = _tmp83_[_tmp84_];
			_tmp86_ = data;
			_tmp86__length1 = data_length1;
			_tmp87_ = i;
			_tmp88_ = _tmp86_[_tmp87_ + 1];
			_tmp89_ = data;
			_tmp89__length1 = data_length1;
			_tmp90_ = i;
			_tmp91_ = _tmp89_[_tmp90_ + 2];
			_tmp92_ = data;
			_tmp92__length1 = data_length1;
			_tmp93_ = i;
			_tmp94_ = _tmp92_[_tmp93_ + 3];
			self->priv->m_workarea.width = (gint) (((_tmp85_ | (_tmp88_ << 8)) | (_tmp91_ << 16)) | (_tmp94_ << 24));
			_tmp95_ = i;
			i = _tmp95_ + 4;
			_tmp96_ = data;
			_tmp96__length1 = data_length1;
			_tmp97_ = i;
			_tmp98_ = _tmp96_[_tmp97_];
			_tmp99_ = data;
			_tmp99__length1 = data_length1;
			_tmp100_ = i;
			_tmp101_ = _tmp99_[_tmp100_ + 1];
			_tmp102_ = data;
			_tmp102__length1 = data_length1;
			_tmp103_ = i;
			_tmp104_ = _tmp102_[_tmp103_ + 2];
			_tmp105_ = data;
			_tmp105__length1 = data_length1;
			_tmp106_ = i;
			_tmp107_ = _tmp105_[_tmp106_ + 3];
			self->priv->m_workarea.height = (gint) (((_tmp98_ | (_tmp101_ << 8)) | (_tmp104_ << 16)) | (_tmp107_ << 24));
			data = (g_free (data), NULL);
			_g_object_unref0 (root);
		}
	}
	self->priv->m_move_begined = TRUE;
	_tmp108_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	_tmp109_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp108_, GTK_TYPE_WINDOW, GtkWindow));
	toplevel = _tmp109_;
	_tmp110_ = toplevel;
	gtk_window_get_position (_tmp110_, &_tmp111_, &_tmp112_);
	x = _tmp111_;
	y = _tmp112_;
	_tmp113_ = event;
	_tmp114_ = _tmp113_->x_root;
	_tmp115_ = x;
	self->priv->m_press_pos.x = ((gint) _tmp114_) - _tmp115_;
	_tmp116_ = event;
	_tmp117_ = _tmp116_->y_root;
	_tmp118_ = y;
	self->priv->m_press_pos.y = ((gint) _tmp117_) - _tmp118_;
	g_signal_emit_by_name (self, "move-begin");
	result = TRUE;
	_g_object_unref0 (toplevel);
	return result;
}


static gboolean handle_real_button_release_event (GtkWidget* base, GdkEventButton* event) {
	Handle * self;
	gboolean result = FALSE;
	GdkEventButton* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	GdkWindow* _tmp2_ = NULL;
	GdkCursor* _tmp3_ = NULL;
	GdkCursor* _tmp4_ = NULL;
	self = (Handle*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event;
	_tmp1_ = _tmp0_->button;
	if (_tmp1_ != ((guint) 1)) {
		result = FALSE;
		return result;
	}
	self->priv->m_move_begined = FALSE;
	self->priv->m_press_pos.x = 0;
	self->priv->m_press_pos.y = 0;
	_tmp2_ = gtk_widget_get_window ((GtkWidget*) self);
	_tmp3_ = gdk_cursor_new (GDK_LEFT_PTR);
	_tmp4_ = _tmp3_;
	gdk_window_set_cursor (_tmp2_, _tmp4_);
	_g_object_unref0 (_tmp4_);
	g_signal_emit_by_name (self, "move-end");
	result = TRUE;
	return result;
}


static gboolean handle_real_motion_notify_event (GtkWidget* base, GdkEventMotion* event) {
	Handle * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GtkWindow* toplevel = NULL;
	GtkWidget* _tmp1_ = NULL;
	GtkWindow* _tmp2_ = NULL;
	gint x = 0;
	GdkEventMotion* _tmp3_ = NULL;
	gdouble _tmp4_ = 0.0;
	GdkPoint _tmp5_ = {0};
	gint _tmp6_ = 0;
	gint y = 0;
	GdkEventMotion* _tmp7_ = NULL;
	gdouble _tmp8_ = 0.0;
	GdkPoint _tmp9_ = {0};
	gint _tmp10_ = 0;
	gboolean _tmp11_ = FALSE;
	gint _tmp12_ = 0;
	GdkRectangle _tmp13_ = {0};
	gint _tmp14_ = 0;
	gboolean _tmp20_ = FALSE;
	gint _tmp21_ = 0;
	GdkRectangle _tmp22_ = {0};
	gint _tmp23_ = 0;
	gint w = 0;
	gint h = 0;
	GtkWindow* _tmp29_ = NULL;
	gint _tmp30_ = 0;
	gint _tmp31_ = 0;
	gboolean _tmp32_ = FALSE;
	gint _tmp33_ = 0;
	gint _tmp34_ = 0;
	GdkRectangle _tmp35_ = {0};
	gint _tmp36_ = 0;
	GdkRectangle _tmp37_ = {0};
	gint _tmp38_ = 0;
	gboolean _tmp50_ = FALSE;
	gint _tmp51_ = 0;
	gint _tmp52_ = 0;
	GdkRectangle _tmp53_ = {0};
	gint _tmp54_ = 0;
	GdkRectangle _tmp55_ = {0};
	gint _tmp56_ = 0;
	GtkWindow* _tmp68_ = NULL;
	gint _tmp69_ = 0;
	gint _tmp70_ = 0;
	self = (Handle*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->m_move_begined;
	if (!_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp1_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GTK_TYPE_WINDOW, GtkWindow));
	toplevel = _tmp2_;
	_tmp3_ = event;
	_tmp4_ = _tmp3_->x_root;
	_tmp5_ = self->priv->m_press_pos;
	_tmp6_ = _tmp5_.x;
	x = (gint) (_tmp4_ - _tmp6_);
	_tmp7_ = event;
	_tmp8_ = _tmp7_->y_root;
	_tmp9_ = self->priv->m_press_pos;
	_tmp10_ = _tmp9_.y;
	y = (gint) (_tmp8_ - _tmp10_);
	_tmp12_ = x;
	_tmp13_ = self->priv->m_workarea;
	_tmp14_ = _tmp13_.x;
	if (_tmp12_ < _tmp14_) {
		gint _tmp15_ = 0;
		GdkRectangle _tmp16_ = {0};
		gint _tmp17_ = 0;
		_tmp15_ = x;
		_tmp16_ = self->priv->m_workarea;
		_tmp17_ = _tmp16_.x;
		_tmp11_ = _tmp15_ > (_tmp17_ - 16);
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
		GdkRectangle _tmp18_ = {0};
		gint _tmp19_ = 0;
		_tmp18_ = self->priv->m_workarea;
		_tmp19_ = _tmp18_.x;
		x = _tmp19_;
	}
	_tmp21_ = y;
	_tmp22_ = self->priv->m_workarea;
	_tmp23_ = _tmp22_.y;
	if (_tmp21_ < _tmp23_) {
		gint _tmp24_ = 0;
		GdkRectangle _tmp25_ = {0};
		gint _tmp26_ = 0;
		_tmp24_ = y;
		_tmp25_ = self->priv->m_workarea;
		_tmp26_ = _tmp25_.y;
		_tmp20_ = _tmp24_ > (_tmp26_ - 16);
	} else {
		_tmp20_ = FALSE;
	}
	if (_tmp20_) {
		GdkRectangle _tmp27_ = {0};
		gint _tmp28_ = 0;
		_tmp27_ = self->priv->m_workarea;
		_tmp28_ = _tmp27_.y;
		y = _tmp28_;
	}
	_tmp29_ = toplevel;
	gtk_window_get_size (_tmp29_, &_tmp30_, &_tmp31_);
	w = _tmp30_;
	h = _tmp31_;
	_tmp33_ = x;
	_tmp34_ = w;
	_tmp35_ = self->priv->m_workarea;
	_tmp36_ = _tmp35_.x;
	_tmp37_ = self->priv->m_workarea;
	_tmp38_ = _tmp37_.width;
	if ((_tmp33_ + _tmp34_) > (_tmp36_ + _tmp38_)) {
		gint _tmp39_ = 0;
		gint _tmp40_ = 0;
		GdkRectangle _tmp41_ = {0};
		gint _tmp42_ = 0;
		GdkRectangle _tmp43_ = {0};
		gint _tmp44_ = 0;
		_tmp39_ = x;
		_tmp40_ = w;
		_tmp41_ = self->priv->m_workarea;
		_tmp42_ = _tmp41_.x;
		_tmp43_ = self->priv->m_workarea;
		_tmp44_ = _tmp43_.width;
		_tmp32_ = (_tmp39_ + _tmp40_) < ((_tmp42_ + _tmp44_) + 16);
	} else {
		_tmp32_ = FALSE;
	}
	if (_tmp32_) {
		GdkRectangle _tmp45_ = {0};
		gint _tmp46_ = 0;
		GdkRectangle _tmp47_ = {0};
		gint _tmp48_ = 0;
		gint _tmp49_ = 0;
		_tmp45_ = self->priv->m_workarea;
		_tmp46_ = _tmp45_.x;
		_tmp47_ = self->priv->m_workarea;
		_tmp48_ = _tmp47_.width;
		_tmp49_ = w;
		x = (_tmp46_ + _tmp48_) - _tmp49_;
	}
	_tmp51_ = y;
	_tmp52_ = h;
	_tmp53_ = self->priv->m_workarea;
	_tmp54_ = _tmp53_.y;
	_tmp55_ = self->priv->m_workarea;
	_tmp56_ = _tmp55_.height;
	if ((_tmp51_ + _tmp52_) > (_tmp54_ + _tmp56_)) {
		gint _tmp57_ = 0;
		gint _tmp58_ = 0;
		GdkRectangle _tmp59_ = {0};
		gint _tmp60_ = 0;
		GdkRectangle _tmp61_ = {0};
		gint _tmp62_ = 0;
		_tmp57_ = y;
		_tmp58_ = h;
		_tmp59_ = self->priv->m_workarea;
		_tmp60_ = _tmp59_.y;
		_tmp61_ = self->priv->m_workarea;
		_tmp62_ = _tmp61_.height;
		_tmp50_ = (_tmp57_ + _tmp58_) < ((_tmp60_ + _tmp62_) + 16);
	} else {
		_tmp50_ = FALSE;
	}
	if (_tmp50_) {
		GdkRectangle _tmp63_ = {0};
		gint _tmp64_ = 0;
		GdkRectangle _tmp65_ = {0};
		gint _tmp66_ = 0;
		gint _tmp67_ = 0;
		_tmp63_ = self->priv->m_workarea;
		_tmp64_ = _tmp63_.y;
		_tmp65_ = self->priv->m_workarea;
		_tmp66_ = _tmp65_.height;
		_tmp67_ = w;
		y = (_tmp64_ + _tmp66_) - _tmp67_;
	}
	_tmp68_ = toplevel;
	_tmp69_ = x;
	_tmp70_ = y;
	gtk_window_move (_tmp68_, _tmp69_, _tmp70_);
	result = TRUE;
	_g_object_unref0 (toplevel);
	return result;
}


static gboolean handle_real_draw (GtkWidget* base, cairo_t* cr) {
	Handle * self;
	gboolean result = FALSE;
	cairo_t* _tmp0_ = NULL;
	GdkWindow* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	self = (Handle*) base;
	g_return_val_if_fail (cr != NULL, FALSE);
	_tmp0_ = cr;
	_tmp1_ = gtk_widget_get_window ((GtkWidget*) self);
	_tmp2_ = gtk_cairo_should_draw_window (_tmp0_, _tmp1_);
	if (_tmp2_) {
		GtkStyleContext* context = NULL;
		GtkStyleContext* _tmp3_ = NULL;
		GtkStyleContext* _tmp4_ = NULL;
		GtkAllocation allocation = {0};
		GtkAllocation _tmp5_ = {0};
		GtkStyleContext* _tmp6_ = NULL;
		cairo_t* _tmp7_ = NULL;
		GtkAllocation _tmp8_ = {0};
		gint _tmp9_ = 0;
		GtkAllocation _tmp10_ = {0};
		gint _tmp11_ = 0;
		GtkAllocation _tmp12_ = {0};
		gint _tmp13_ = 0;
		GtkAllocation _tmp14_ = {0};
		gint _tmp15_ = 0;
		_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) self);
		_tmp4_ = _g_object_ref0 (_tmp3_);
		context = _tmp4_;
		gtk_widget_get_allocation ((GtkWidget*) self, &_tmp5_);
		allocation = _tmp5_;
		_tmp6_ = context;
		_tmp7_ = cr;
		_tmp8_ = allocation;
		_tmp9_ = _tmp8_.x;
		_tmp10_ = allocation;
		_tmp11_ = _tmp10_.y;
		_tmp12_ = allocation;
		_tmp13_ = _tmp12_.height;
		_tmp14_ = allocation;
		_tmp15_ = _tmp14_.width;
		gtk_render_handle (_tmp6_, _tmp7_, (gdouble) _tmp9_, (gdouble) (_tmp11_ + ((_tmp13_ - 40) / 2)), (gdouble) _tmp15_, 40.0);
		_g_object_unref0 (context);
	}
	result = FALSE;
	return result;
}


static void handle_class_init (HandleClass * klass) {
	handle_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (HandlePrivate));
	GTK_WIDGET_CLASS (klass)->realize = handle_real_realize;
	GTK_WIDGET_CLASS (klass)->button_press_event = handle_real_button_press_event;
	GTK_WIDGET_CLASS (klass)->button_release_event = handle_real_button_release_event;
	GTK_WIDGET_CLASS (klass)->motion_notify_event = handle_real_motion_notify_event;
	GTK_WIDGET_CLASS (klass)->draw = handle_real_draw;
	G_OBJECT_CLASS (klass)->finalize = handle_finalize;
	g_signal_new ("move_begin", TYPE_HANDLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("move_end", TYPE_HANDLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void handle_instance_init (Handle * self) {
	self->priv = HANDLE_GET_PRIVATE (self);
}


static void handle_finalize (GObject* obj) {
	Handle * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HANDLE, Handle);
	G_OBJECT_CLASS (handle_parent_class)->finalize (obj);
}


GType handle_get_type (void) {
	static volatile gsize handle_type_id__volatile = 0;
	if (g_once_init_enter (&handle_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (HandleClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) handle_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Handle), 0, (GInstanceInitFunc) handle_instance_init, NULL };
		GType handle_type_id;
		handle_type_id = g_type_register_static (GTK_TYPE_EVENT_BOX, "Handle", &g_define_type_info, 0);
		g_once_init_leave (&handle_type_id__volatile, handle_type_id);
	}
	return handle_type_id__volatile;
}



